<script>
import axios from 'axios';
import PromptWindow from '@/components/PromptWindow.vue';
import {getSettings} from '../utils/commonUtils';

export default {
  name: 'App',
  components: { PromptWindow },
  data() {
    return {
      pageId: '',
      settings: {},
      infoObject: {},
      isLoaded: false,
      extensionId: '',
    };
  },
  async mounted() {
    this.extensionId = document.getElementById('ai-button')?.getAttribute('extensionId');

    const settings = await getSettings(this.extensionId);
    this.mountSettings(settings);
    this.mountInfoObject();
  },
  methods: {
    mountInfoObject() {
      const body = document.querySelector('body');
      if (!body) {
        console.error('Failed to find body element dataset');
        return;
      }

      const { page, pageTypeId } = body.dataset;

      this.pageId = page;
      this.infoObject.filePath = pageTypeId;
      this.infoObject.pageId = this.pageId;
  
      if (this.pageId === 'projects:blob:show') {
        this.loadBlobContent(window.location.href);
      }
    },
    mountSettings(response) {
      console.log('overlay: received settings %o', response);
      this.settings = {...response?.persisted, ...response?.session} || {};
      this.isLoaded = true;
    },
    loadBlobContent(url) {
      const newUrl = url.replace('/-/blob/', '/-/raw/');
      // Axios GET Default
      axios.get(newUrl).then((response) => {
        this.infoObject.code = response.data;
        console.log('code loaded: %o', this.infoObject.code);
      });
    },
  }
};
</script>

<template>
  <div>
    <div v-if="isLoaded">
    <PromptWindow :extension-id="extensionId" v-bind:infoObject="infoObject" v-bind:settings="settings"></PromptWindow>  
    </div>
</div>
</template>
